﻿<?php if (!defined('PmWiki')) exit();

/*

 Add Persistent Login for authuser.php Using Cookie

 -- Copyright --

 Copyright 2010 by Elias Soong (elias.soong@gmail.com)

 -- License --

 GNU GPL

 -- Description & Installation Instructions --

 See PmWiki AuthUserCookie Cookbook for details
 http://www.pmwiki.org/wiki/Cookbook/AuthUserCookie

 0.1  Elias Soong - Initial version                   

*/

$AuthUserCookie = 1;

// Cookie settings
// Cookie default expiration in seconds
SDV($AuthUserCookieExp, 60*60*24*30);

if (!@$LogoutCookies) $LogoutCookies = array();
$LogoutCookies = array_merge($LogoutCookies, array('AuthUserUsername', 'AuthUserPassword'));

if (@$_POST['authid']) {
  if (@$_POST['persistent']) {
    include_once('Crypt/TripleDES.php');
    $des = new Crypt_TripleDES();
    $des->setKey($AuthUserCookieKey);
    setCookie($CookiePrefix.'AuthUserUsername', @$_POST['authid'], time()+$AuthUserCookieExp, '/');
    setCookie($CookiePrefix.'AuthUserPassword', base64_encode($des->encrypt(@$_POST['authpw'])), time()+$AuthUserCookieExp, '/');
  }
} else {
  @session_start();
  if (!@$_SESSION['authid']) 
    if(@$_COOKIE[$CookiePrefix.'AuthUserUsername']) {
      include_once('Crypt/TripleDES.php');
      $des = new Crypt_TripleDES();
      $des->setKey($AuthUserCookieKey);
      $_POST['authid'] = @$_COOKIE[$CookiePrefix.'AuthUserUsername'];
      $_POST['authpw'] = $des->decrypt(base64_decode(@$_COOKIE[$CookiePrefix.'AuthUserPassword']));
    }
}

?>
